'use strict';

var _require = require('fetch-ponyfill')(),
    fetch = _require.fetch;

var intoStream = require('into-stream').object;

var createStation = function createStation(s) {
	var station = {
		type: 'station',
		id: s.stn_cd + '',
		name: s.stn_nm,
		location: {
			type: 'location',
			longitude: +s.longitude,
			latitude: +s.latitude
		},
		group: s.group // todo
	};
	if (s.major) station.major = s.major; // todo
	return station;
};

var allAsync = async function allAsync(opt) {
	var results = await fetch('https://smart.letskorail.com/classes/com.korail.mobile.common.stationdata');
	results = await results.json();
	return results.stns.stn.map(createStation);
};

var all = function all() {
	var opt = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	return intoStream(allAsync(opt));
};
all.features = {}; // required by fpti

module.exports = { all: all };