'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _require = require('fetch-ponyfill')(),
    fetch = _require.fetch;

var _require2 = require('query-string'),
    stringify = _require2.stringify;

var _require3 = require('luxon'),
    DateTime = _require3.DateTime;

var isString = require('lodash/isString');

var createISODate = function createISODate(_ref) {
	var day = _ref.day,
	    time = _ref.time;
	return DateTime.fromFormat(day + ' ' + time, 'yyyyMMdd HHmmss', { zone: 'Asia/Seoul' }).toISO();
};

var createStopover = function createStopover(s) {
	var arrival = null;
	if (s.h_arv_tm !== '999999') {
		arrival = createISODate({ day: s.h_arv_dt, time: s.h_arv_tm });
	}
	var departure = null;
	if (s.h_dpt_tm !== '999999') {
		departure = createISODate({ day: s.h_dpt_dt, time: s.h_dpt_tm });
	}

	return {
		type: 'stopover',
		stop: {
			type: 'station',
			id: s.h_stop_rs_stn_cd + '',
			name: s.h_stop_rs_stn_nm
		},
		arrival: arrival,
		departure: departure
		// todo: h_act_arv_dlay_tnum
	};
};

var tripStopovers = async function tripStopovers(tripId) {
	if (!isString(tripId) || tripId.length === 0) throw new Error('invalid or missing `tripId`, must be string');

	var _tripId$split = tripId.split('###'),
	    _tripId$split2 = _slicedToArray(_tripId$split, 2),
	    lineId = _tripId$split2[0],
	    day = _tripId$split2[1]; // @todo

	if (!isString(lineId) || lineId.length === 0) throw new Error('invalid `tripId`');
	if (!isString(day) || day.length !== 8) throw new Error('invalid `tripId`');

	var endpoint = 'https://smart.letskorail.com/classes/com.korail.mobile.trainsInfo.TrainSchedule';
	var query = stringify({
		Device: 'IP',
		// Sid: '1QihOasC3e4vT2ld1RRiMw==',
		// Version: '180314001',
		srtCheckYn: 'Y',
		txtRunDt: day,
		txtTrnNo: lineId
	});
	var url = endpoint + '?' + query;
	var results = await fetch(url, { method: 'POST' });
	results = await results.json();

	if (results.strResult !== 'SUCC') throw new Error(JSON.stringify(results));
	return results.time_infos.time_info.map(createStopover);
};
tripStopovers.features = {}; // required by fpti

module.exports = tripStopovers;